
:- ['../util.pl'].
:- ['../acyclicity'].

:- begin_tests(acyclicity).

%%
% Testing is_cyclic_on_mv/2
%

test(is_cyclic_on_mv) :-
	is_cyclic_on_mv([[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a).

test(is_cyclic_on_mv) :-
	is_cyclic_on_mv([[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a).
	
test(is_cyclic_on_mv, fail) :-
	is_cyclic_on_mv([[[[], [a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a).
	
test(is_cyclic_on_mv, fail) :-
	is_cyclic_on_mv([[[[], [a, 'Y'+4]]], [[[], [-a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a).	
	
test(is_cyclic_on_mv, fail) :-
	is_cyclic_on_mv([[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[-b, 'Y'+1]]], [[[],[b, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a).	
	
%%
% Testing convert_to_acyclic/3
%

test(convert_to_acyclic) :-
	convert_to_acyclic(
	[[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[-b, 'Y'+1]]], [[[],[b, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], % already acyclic
	a, 
	[[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[-b, 'Y'+1]]], [[[],[b, 'Y'+1]]], [[[],[a, 'Y'+1]]] ]).
	
test(convert_to_acyclic) :-
	convert_to_acyclic(
	[[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], 
	a, 
	[[[[], [a, a, 'Y'+4]]], [[[], [-a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]]]).

test(convert_to_acyclic) :-
	convert_to_acyclic(
	[[[[], [a, a, 'Y'+4]]], [[[], [-a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], 
	a, 
	[[[[], [a, a, 'Y'+4]]], [[[], [a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]]]).
	
test(convert_to_acyclic) :-
	convert_to_acyclic(
	[[[[], [a, 'Y'+1]]], [[[], [b, 'Y'+2]]], [[[],[-a, -a, -b, 'Y'+3]]], [[[],[-b, -b, -a, 'Y'+3]]] ],  % already acyclic
	a, 
	[[[[], [a, 'Y'+1]]], [[[], [b, 'Y'+2]]], [[[],[-a, -a, -b, 'Y'+3]]], [[[],[-b, -b, -a, 'Y'+3]]] ]).

%%
% Testing apply_weakening_on_mv/3
%

test(apply_weakening_on_mv) :-
	apply_weakening_on_mv(
	[[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, a, 'Y'+4]]],  [[[], [-a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[-a, a, 'Y'+1]]] ], 
	-a, 
	[[[[], [a, a, 'Y'+4]]], [[[], [a, 'Y'+4]]], [[[],[-a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ] ).

test(apply_weakening_on_mv) :-
	apply_weakening_on_mv(
	[[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], 
	-a, 
	[[[[], [a, a, 'Y'+4]]], [[[], [a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ]).

%%
% Testing count_having_multi_occurrence/3
%

test(count_having_multi_occurrence) :-
	count_having_multi_occurrence([[[[], [a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, 1).
	
test(count_having_multi_occurrence) :-
	count_having_multi_occurrence([[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, 2).

test(count_having_multi_occurrence) :-
	count_having_multi_occurrence([[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[], [a, a, a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, 3).

test(count_having_multi_occurrence) :-
	count_having_multi_occurrence(
	[[[[], [-a, -a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[], [-a, -a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[-b, 'Y'+1]]] ], 
	-a, 3).

test(count_having_multi_occurrence) :-
	count_having_multi_occurrence(
	[[[[], [-a, -a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]] ], 
	-a, 2).
	
test(count_having_multi_occurrence) :-
	count_having_multi_occurrence(
	[[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], 
	-a, 0).	


%%
% Testing count_having_mixed_occurrence/3
%

test(count_having_mixed_occurrence) :-
	count_having_mixed_occurrence(
		[[[[], [-a, -a, 'Y'+4]]], [[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], 
		a, 0).

test(count_having_mixed_occurrence) :-
	count_having_mixed_occurrence(
		[[[[], [-a, -a, a, a, 'Y'+4]]], [[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], 
		a, 1).
		
test(count_having_mixed_occurrence) :-
	count_having_mixed_occurrence(
		[[[[], [a, 'Y'+4]]], [[[], [a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], 
		a, 0).	

:- end_tests(acyclicity).


% Tests
	
% positive
% count_having_multi_occurrence([[[[], [a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, X).
% count_having_multi_occurrence([[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, X).
% count_having_multi_occurrence([[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[], [a, a, a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, X).

% negative
% count_having_multi_occurrence([[[[], [-a, -a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[], [-a, -a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[-b, 'Y'+1]]] ], -a, X).
% count_having_multi_occurrence([[[[], [-a, -a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]] ], -a, X).
% count_having_multi_occurrence([[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], -a, X).
% count_having_multi_occurrence([[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], -a, X).

% mixed
% count_having_mixed_occurrence([[[[], [-a, -a, 'Y'+4]]], [[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, X).
% count_having_mixed_occurrence([[[[], [-a, -a, a, a, 'Y'+4]]], [[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, X).
% count_having_mixed_occurrence([[[[], [a, 'Y'+4]]], [[[], [a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, X).

% has_mixed_polarities_mv([-a, -a, 'Y'+4], a, X).


% apply_weakening_on_mv([[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], -a, X).

%true:  is_cyclic_on_mv([[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a).
%true:  is_cyclic_on_mv([[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a).
%false: is_cyclic_on_mv([[[[], [a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a). 
%false: is_cyclic_on_mv([[[[], [a, 'Y'+4]]], [[[], [-a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a). 
%false: is_cyclic_on_mv([[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[-b, 'Y'+1]]], [[[],[b, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a). 



% convert_to_acyclic([[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[-b, 'Y'+1]]], [[[],[b, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a, X).
% convert_to_acyclic([[[[], [a, a, 'Y'+4]]], [[[], [-a, -a, -a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a, X).
% convert_to_acyclic([[[[], [a, a, 'Y'+4]]], [[[], [-a, a, 'Y'+4]]], [[[],[-a, 'Y'+1]]], [[[],[a, 'Y'+1]]] ], a, X).
% convert_to_acyclic([[[[], [a, 'Y'+1]]], [[[], [b, 'Y'+2]]], [[[],[-a, -a, -b, 'Y'+3]]], [[[],[-b, -b, -a, 'Y'+3]]] ], a, X).
 
