
:- ['../acyclicity'].
:- ['../util.pl'].
:- ['../analytic.pl'].

:- begin_tests(analytic).

%%%%%%%%%%%%%%%%%%%%  cut/3  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

test(cut) :-
	cut(
	[[[[], [-b, -b, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, -b, 'Y'+1]]], [[[], ['Y'+3, b]]]],
	[[[[], ['Y'+3, 'Y'+3, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, 'Y'+3, 'Y'+1]]]], 
	0).

test(cut) :-   
	cut(
	[[[[], [-b, -b, -a, 'Y'+1]]], [[[], [-a, -a, -b, 'Y'+1]]], [[[], ['Y'+2, a]]], [[[], ['Y'+3, b]]]],
	[[[[], ['Y'+3, 'Y'+3, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, 'Y'+3, 'Y'+1]]]], 
	0).
	
%%%%%%%%%%%%%%%%%%%%  are_metafree_premises/4  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

test(cut_metavariable) :-
	cut_metavariable(
	[[[[], [-b, -b, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, -b, 'Y'+1]]], [[[], ['Y'+3, b]]]], 
	[[[[], ['Y'+3, 'Y'+3, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, 'Y'+3, 'Y'+1]]]], 
	b, 0).
	
test(cut_metavariable) :-
	cut_metavariable(
	[[[[], [-b, -b, -a, 'Y'+1]]], [[[], [-a, -a, -b, 'Y'+1]]], [[[], ['Y'+2, a]]], [[[], ['Y'+3, b]]]],
	[[[[], ['Y'+2, a]]], [[[], ['Y'+3, 'Y'+3, -a, 'Y'+1]]], [[[], [-a, -a, 'Y'+3, 'Y'+1]]]], 
	b, 0).
	
test(cut_metavariable) :-
	cut_metavariable(
	[[[[], [-b, -b, -a, 'Y'+1]]], [[[], [-a, -a, -b, 'Y'+1]]], [[[], ['Y'+2, a]]], [[[], ['Y'+3, b]]]],
	[[[[], ['Y'+3, b]]], [[[], [-b, -b, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, -b, 'Y'+1]]]], 
	a, 0).

%%%%%%%%%%%%%%%%%%%%  are_metafree_premises/1  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
test(are_metafree_premises, fail) :-
	are_metafree_premises([[[[], [-b, -b, -a, 'Y'+1]]], [[[], [-a, -a, -b, 'Y'+1]]], [[[], ['Y'+2, a]]], [[[], ['Y'+3, b]]]]).
	
test(are_metafree_premises, fail) :-
	are_metafree_premises([[[[], ['Y'+3, 'Y'+3, -a, 'Y'+1]]], [[[], [-a, -a, 'Y'+3, 'Y'+1]]], [[[], ['Y'+2, a]]]]).
	
test(are_metafree_premises, fail) :-
	are_metafree_premises([[[[], [-b, -b, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, -b, 'Y'+1]]], [[[], ['Y'+3, b]]]]).
	
% positive occurrences only
test(are_metafree_premises, fail) :-
	are_metafree_premises([[[[], [b, b, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, b, 'Y'+1]]], [[[], ['Y'+3, b]]]]).

% negative occurrences only
test(are_metafree_premises, fail) :-
	are_metafree_premises([[[[], [-b, -b, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, -b, 'Y'+1]]], [[[], ['Y'+3, -b]]]]).
	
% single premise
test(are_metafree_premises, fail) :-
	are_metafree_premises([[[[], [-b, 'Y'+2, 'Y'+1]]]]).

test(are_metafree_premises) :-
	are_metafree_premises([[[[], ['Y'+3, 'Y'+3, 'Y'+2, 'Y'+1]]], [[[], ['Y'+2, 'Y'+2, 'Y'+3, 'Y'+1]]]]).
	
	
% collect_by_mv/5
test(collect_by_mv) :-
	collect_by_mv(
		[[[[], [-b, -b, -a, 'Y'+1]]], [[[], [-a, -a, -b, 'Y'+1]]], [[[], ['Y'+2, a]]], [[[], ['Y'+3, b]]]],
		a,
		[[[[], [-b, -b, -a, 'Y'+1]]], [[[], [-a, -a, -b, 'Y'+1]]], [[[], ['Y'+2, a]]]],
		1, 2).


% cut_mv_from_premise


% remove_premises


% separate_premises


% simple_merge_neg

% simple_merge_pos

% combinatorial_merge_pos
%test(combinatorial_merge_pos) :-
%	combinatorial_merge_pos(
%		[[[[], [a, a, 'Y'+3]]], [[[], [a, a, 'Y'+4]]]], [ [[[],[-a, 'Y'+1]]] , [[[],[-a, 'Y'+2]]] ], 
%		[], 2, a).

% combinatorial_merge_neg

%test(combinatorial_merge_neg) :- 
%	combinatorial_merge_neg(
%	[[[[], [-a, -a, 'Y'+4]]]], [ [[[],[a, 'Y'+1]]] , [[[],[a, 'Y'+2]]], [[[],[a, 'Y'+3]]] ], 
%	[[[[], ['Y'+1, 'Y'+1, 'Y'+4]]], [[[], ['Y'+1, 'Y'+2, 'Y'+4]]], [[[], ['Y'+2, 'Y'+2, 'Y'+4]]]], 
%	3, a
%	). [[[[], [-b, -b, -a, 'Y'+1]]], [[[], [-a, -a, -b, 'Y'+1]]], [[[], ['Y'+2, a]]], [[[], ['Y'+3, b]]]]

% generate_combination

% combine_with_repetitions

% create_new_premises


% separate_premises 

test(separate_premises) :-
	separate_premises( 
	[[[[],[-b,-b,-a,'Y'+1]]],[[[],[a,a,-b,'Y'+1]]],[[[],['Y'+2,a]]]],
	[[[[],[a,a,-b,'Y'+1]]],[[[],['Y'+2,a]]]],
	[[[[],[-b,-b,-a,'Y'+1]]]],
	a).

% count_premises_with_multi_pos_mv

test(count_premises_with_multi_pos_mv) :- 
	count_premises_with_multi_pos_mv(
		[[[[], [a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], 
			a, 1).
			
test(count_premises_with_multi_pos_mv) :- 
	count_premises_with_multi_pos_mv(
		[[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], 
			a, 2).
			
test(count_premises_with_multi_pos_mv) :- 
	count_premises_with_multi_pos_mv(
		[[[[], [a, 'Y'+4]]], [[[], [a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], 
			a, 0).

% fac
:- end_tests(analytic).

% [[[[[], [-b, -b, -a, 'Y'+1]]], [[[], [-a, -a, -b, 'Y'+1]]], [[[], ['Y'+2, a]]], [[[], ['Y'+3, b]]]], [[[], ['Y'+1, 'Y'+2, 'Y'+3]]]]

% combinatorial_merge_pos([[[[], [a, a, 'Y'+3]]], [[[], [a, a, 'Y'+4]]]], [ [[[],[-a, 'Y'+1]]] , [[[],[-a, 'Y'+2]]] ], X, 2, a).
% combinatorial_merge_pos([[[[], [a, a, 'Y'+3]]], [[[], [a, a, 'Y'+4]]]], [ [[[],[-a, 'Y'+1]]] , [[[],[-a, 'Y'+2]]] ], X, 2, a).
% combinatorial_merge_pos([[[[], [a, a, 'Y'+4]]]], [ [[[],[-a, 'Y'+1]]] , [[[],[-a, 'Y'+2]]], [[[],[-a, 'Y'+3]]] ], X, 3, a).
% combinatorial_merge_neg([[[[], [-a, -a, 'Y'+4]]]], [ [[[],[a, 'Y'+1]]] , [[[],[a, 'Y'+2]]], [[[],[a, 'Y'+3]]] ], X, 3, a).
% combinatorial_merge_neg([[[[], [-a, -a, 'Y'+4]]]], [ [[[],[a, 'Y'+1]]] , [[[],[a, 'Y'+2]]], [[[],[a, 'Y'+3]]] ], X, 3, a).




% have_metavar([[[[],[-b,-b,-a,'Y'+1]]],[[[],[a,a,-b,'Y'+1]]],[[[],['Y'+2,a]]],[[[],['Y'+3,b]]]], a).


% collect_by_mv([[[[],[-b,-b,-a,'Y'+1]]],[[[],[a,a,-b,'Y'+1]]],[[[],['Y'+2,a]]],[[[],['Y'+3,b]]]], a, P1, NumPos, NumNeg).
% collect_by_mv([[[[],[-b,-b,-a,'Y'+1]]],[[[],[a,a,-b,'Y'+1]]],[[[],['Y'+2,a]]],[[[],['Y'+3,b]]]],a,P1,NumPos,NumNeg).


% tests
test_htoa_ms_r(Axiom, Class, Result1) :-
	aths_ms_r(Axiom, Class, Result0),
	writef('\n ======= \n ====== \n after applying aths_ms_r(): Result0: %q.',[Result0]), %,
	htoa_ms_r(Result0, Result1, N),
	writef('\n ======= \n ====== \n after applying htoa_ms_r(): Result0: %q \n %q.',[Result1, N]).
% test_htoa_ms_r( ( ((a * a * b) v (b * b * a) ) + -a + -b ), n(1), X).
% combinatorial_merge_pos([[[[], [a, a, 'Y'+3]]], [[[], [a, a, 'Y'+4]]]], [ [[[],[-a, 'Y'+1]]] , [[[],[-a, 'Y'+2]]] ], X, 2, a).
% combinatorial_merge_pos([[[[], [a, a, 'Y'+3]]], [[[], [a, a, 'Y'+4]]]], [ [[[],[-a, 'Y'+1]]] , [[[],[-a, 'Y'+2]]] ], X, 2, a).
% combinatorial_merge_pos([[[[], [a, a, 'Y'+4]]]], [ [[[],[-a, 'Y'+1]]] , [[[],[-a, 'Y'+2]]], [[[],[-a, 'Y'+3]]] ], X, 3, a).
% combinatorial_merge_neg([[[[], [-a, -a, 'Y'+4]]]], [ [[[],[a, 'Y'+1]]] , [[[],[a, 'Y'+2]]], [[[],[a, 'Y'+3]]] ], X, 3, a).
% combinatorial_merge_neg([[[[], [-a, -a, 'Y'+4]]]], [ [[[],[a, 'Y'+1]]] , [[[],[a, 'Y'+2]]], [[[],[a, 'Y'+3]]] ], X, 3, a).



% count_premises_with_multi_pos_mv([[[[], [a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, X).
% count_premises_with_multi_pos_mv([[[[], [a, a, 'Y'+4]]], [[[], [a, a, a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, X).
% count_premises_with_multi_pos_mv([[[[], [a, 'Y'+4]]], [[[], [a, 'Y'+4]]], [[[],[a, 'Y'+1]]] ], a, X).

% have_metavar([[[[],[-b,-b,-a,'Y'+1]]],[[[],[a,a,-b,'Y'+1]]],[[[],['Y'+2,a]]],[[[],['Y'+3,b]]]], a).


% collect_by_nv([[[[],[-b,-b,-a,'Y'+1]]],[[[],[a,a,-b,'Y'+1]]],[[[],['Y'+2,a]]],[[[],['Y'+3,b]]]], a, P1, NumPos, NumNeg, NumCyclic).
% collect_by_mv([[[[],[-b,-b,-a,'Y'+1]]],[[[],[a,a,-b,'Y'+1]]],[[[],['Y'+2,a]]],[[[],['Y'+3,b]]]],a,P1,NumPos,NumNeg,NumCyclic).


